package com.xynet.marketing.utils;

import com.cow.support.dto.UserSessionModel;
import com.xynet.marketing.service.MercService;
import com.xynet.marketing.utils.error.BusinessException;
import com.xynet.marketing.utils.redis.utils.RedisService;

import java.util.Map;

/**
 * @author hechunping
 * @date 2025/2/12
 */
public class MercAuthUtils {
    //private static String redisPrefix = "marketing:token:merc:";

    private static String redisPrefix = "userSession-";

    public static Integer getMercId(Map<String, String> headers) {
        //获取token
        String token = headers.get("token");
        String providerId = headers.get("provider-id");
        RedisService<UserSessionModel> redisService = SpringBeanUtils.getBean(RedisService.class);
        if (!Emptys.check(token)) {
            throw new BusinessException("token不能为空");
        }
        if (!Emptys.check(providerId)) {
            throw new BusinessException("服务商ID不能为空");
        }
        //判断redis里是否有对应的商户ID
        UserSessionModel userSession = redisService.get(redisPrefix + token);
        if (!Emptys.check(userSession)) {
            throw new BusinessException("token已过期");
        }
        String thirdMercId = userSession.getUserInfo().getShbh();
        MercService mercService = SpringBeanUtils.getBean(MercService.class);
        return mercService.thirdMercIdToMercId(providerId, thirdMercId);
    }

//    public static Integer getMercId1(Map<String, String> headers) {
//        //获取token
//        String token = headers.get("token");
//        String providerId = headers.get("provider_id");
//        RedisService<Integer> redisService = SpringBeanUtils.getBean(RedisService.class);
//        if (!Emptys.check(token)) {
//            throw new BusinessException("token不能为空");
//        }
//        if (!Emptys.check(providerId)) {
//            throw new BusinessException("服务商ID不能为空");
//        }
//        //判断redis里是否有对应的商户ID
//        Integer mercId = redisService.get(redisPrefix + providerId + ":" + token);
//        if (!Emptys.check(mercId)) {
//            //redis不存在，调用服务商获取商户ID的接口
//            mercId = getMercIdByProvider(token, providerId);
//            //将token存到redis中
//            redisService.set(redisPrefix + providerId + ":" + token, mercId, 7200);
//        }
//        return mercId;
//    }

//    private static Integer getMercIdByProvider(String token, String providerId) {
//        ProviderService providerService = SpringBeanUtils.getBean(ProviderService.class);
//        JHashMap<String, Object> param = new JHashMap<>();
//        param.set("id", providerId);
//        Map<String, Object> provider = providerService.obj(param);
//        //HttpUtil.post(provider.);
//        //TODO 调用第三方
//        return 1;
//    }

}
